/* $Id: io.h,v 1.1 2000/11/11 09:02:33 honda Exp $
 *
 * io.h
 *
 * Modifications for the uITRON4.0 specification OS "TOPPERS" by Shinya Honda
 *
 * This file is subject to the terms and conditions of the GNU Lesser
 * General Public License.  See the file "COPYING.LIB" in the main
 * directory of this archive for more details.
 *
 * Implementation taken from ItIs kernel 
 */



#define Inline          static __inline__
#define    Asm             __asm__ volatile

typedef unsigned char   byte;
typedef volatile byte   IOREG;
typedef volatile int    LIOREG;
typedef unsigned int    UINT;
typedef void *VP;
typedef void (*FP)();

Inline int
dve68k_putc(int c)
{
	Asm("moveq.l #5, %%d0; move.l %0, %%d1; trap #3"
	  : /* no output */
	  : "g"(c)
	  : "d0", "d1", "d2", "d6", "d7");
	  return(c);
}


Inline void
cpu_wait_io(void)
{
	Asm("nop");
	Asm("nop");
	Asm("nop");
	Asm("nop");
}


Inline byte
io_read(IOREG *addr)
{
    byte    val;
    val = *addr;
    cpu_wait_io();
    return(val);
}


Inline void
io_write(IOREG *addr, byte val)
{
    *addr = val;
    cpu_wait_io();
}

Inline byte
mpsc_read(IOREG *addr, int reg)
{
    io_write(addr, reg);
    return(io_read(addr));
}

Inline void
mpsc_write(IOREG *addr, int reg, int val)
{
    io_write(addr, reg);
    io_write(addr, val);
}

Inline void
mpsc_write_brg(IOREG *addr, int reg, int val, int brg2, int brg1)
{
	io_write(addr, reg);
	io_write(addr, val);
	io_write(addr, brg2);
	io_write(addr, brg1);
	(void) io_read(addr);		/* ߡ꡼ */
}



/*
 *  MPSC (PD72001-11) Υ쥸
 */

#define	MPSC_DATAA	((IOREG *) 0xfff45003)
#define	MPSC_CNTRLA	((IOREG *) 0xfff45007)
#define	MPSC_DATAB	((IOREG *) 0xfff4500b)
#define	MPSC_CNTRLB	((IOREG *) 0xfff4500f)

#define	MPSC_CR0	0x00		/* MPSC ȥ쥸 */
#define	MPSC_CR1	0x01
#define	MPSC_CR2	0x02
#define	MPSC_CR3	0x03
#define	MPSC_CR4	0x04
#define	MPSC_CR5	0x05
#define	MPSC_CR10	0x0a
#define	MPSC_CR12	0x0c
#define	MPSC_CR14	0x0e
#define	MPSC_CR15	0x0f

#define	MPSC_SR0	0x00		/* MPSC ơ쥸 */




Inline VP
current_vbr()
{
    VP      vbr;
    Asm("movec.l %%vbr, %0" : "=r"(vbr));
    return(vbr);
}

/*
 *  㳰٥ơ֥ι¤
 */
typedef struct exc_vector_entry {
	FP	exchdr;			/* 㳰ϥɥεư */
} EXCVE;



/*
 *  ߥϥɥ
 *
 *  ٥ȥֹ inhno γߥϥɥεưϤ inthdr ꤹ롥
 */
Inline void
exceptionHandler(UINT inhno, FP inthdr)
{
	EXCVE	*excvt;
        
	excvt = (EXCVE *) current_vbr();
	excvt[inhno].exchdr = inthdr;
}





